.org 6639
	.db	0FH,0AH,0,0DDH
	.db	" USR"
	.db	96H,"6659"
	.db	95H,0FFH,0,0,0,0,0	; 20 byte-os fej
;
;
prog:	exx			; program kezdete
	push	bc
	push	de
	push	hl
	exx
	di
	ld	a,50h		; 50h = U0, U1, VID, SYS
	out	(2),a		; memrialapozs belltsa
	ld	(3),a
	ei
	xor	a
	ld	(utvonal),a	; tvonal hatrozatlan
p0:	ld	c,0		; GRAPHICS 2
	rst	48
	.db	4
focikl:	ld	bc,0101h
	rst	48
	.db	35		; CPOS kurzor pozcionlsa:  X=1 Y=1
	ld	bc,mveg-menu
	ld	de,menu		; men kirsa
	rst	48
	.db	34		; ED_BKOUT blokk krsa kpernyre
p1:	rst	48
	.db	145		; KBD_CHIN karakter-beolvass billentyzetrl
	ld	a,c
	sub	48
	jr	c,p1		; ismtls, ha kisebb '0'-nl
	jr	nz,p2
	call	beolvas		; '0' : fjl megnyitsa
	jr	focikl
p2:	dec	a
	jr	nz,p3
	call	kirajz		; '1' : kp megnzse
	rst	48		; vrakozs egy billenty lenyomsra
	.db	145		; KBD_CHIN
	jr	p0
p3:	dec	a
	jr	nz,p1		; '2' : kilps
p4:	exx
	pop	hl
	pop	de
	pop	bc
	exx
	ret
;
menu:	.db	"0-Beolvas  1-Megn",091h,"z  2-Kil",091h,'p'
	.db	0DH,0AH
mveg:
;
beolvas:ld	de,rdfnev
	ld	hl,utvonal
	ld	bc,fulpath
	call	fk_open
	cp	1
	ret	nz
beolv0:	ld	de,fulpath
	rst	48
	.db	211		; CAS_OPEN
	or	a
	jr	nz,beolv3
;	rst	48
;	.db	209		; CAS_CHIN
;	rst	48
;	.db	209
;	rst	48
;	.db	209
;	ld	l,c
;	rst	48
;	.db	209
	ld	bc,0000		; eltols=0000 0000h
	ld	de,0000
	rst	48
	.db	216		; fjlmutat belltsa a fjl vghez kpest
	or	a
	jr	nz,beolv3
	or	b
	or	c
	jr	nz,beolv1
	ld	hl,20000
	sbc	hl,de		; DE>20000 ?
	jr	nc,beolv2
beolv1:	ld	de,20000	; max. 20000 bjt olvassa
beolv2:	ex	de,hl
	ld	(fhossz),hl	; fjlhossz mentse a ksbbiekre
	ld	bc,0000		; eltols=0000 0000h
	ld	de,0000
	rst	48
	.db	214		; fjlmutat belltsa a fjl elejhez kpest
	or	a
	jr	nz,beolv3
	ld	b,h		; BC= beolvasand bjtok
	ld	c,l
	ld	de,keppuff	; DE= tltsi cm
	rst	48
	.db	210		; CAS_BKIN
beolv3:	push	af
	rst	48
	.db	212		; CAS_CLOSE
	pop	af
	or	a
	jp	nz,hibair
	call	kirajz		; kp kirajzolsa
beolv4:	rst	48		; vrakozs egy billenty lenyomsra
	.db	145		; KBD_CHIN
	ld	a,c
	cp	32		; SPACE
	jr	nz,beolv5
	ld	de,rdfnev
	ld	hl,utvonal
	ld	bc,fulpath
	call	fk_nxfn
	or	a
	jp	z,beolv0
	jp	hibair
beolv5:	cp	'v'		; visszalps: 'v' betre
	jr	z,beolv6
	cp	'V'
	jr	nz,beolv7
beolv6:	ld	de,rdfnev
	ld	hl,utvonal
	ld	bc,fulpath
	call	fk_prfn
	or	a
	jp	z,beolv0
	jp	hibair
beolv7:	cp	27		; ESC
	jp	nz,beolv4
	ld	c,0		; GRAPHICS 2
	rst	48
	.db	4
	ret
;
kirajz:	ld	a,(keppuff)	; kp kirajzolsa a kpernyre
	cp	'K'		; fejlc ellenrzse
	ret	nz
	ld	a,(keppuff+1)
	cp	'E'
	ret	nz
	ld	a,(keppuff+2)
	cp	'P'
	ret	nz
	ld	a,(keppuff+3)	; kp tpusa
	and	03h	
	ld	c,a
	rst	48
	.db	4		; VMODE grafikus md: 0-ktszn 1-ngy 2-tizenhat
	ld	hl,(fhossz)	; HL=fjlhossz
	ld	de,4
	or	a
	sbc	hl,de
	ex	de,hl		; DE=fjlhossz-4
	ld	a,(keppuff+3)	; kp tpusa
	cp	2
	jr	z,kepre0	; tmrtetlen 16 szn kpet kzvetlenl kirja
	and	03h
	inc	a
	rla			; A=belltand paletta-regiszterek szma
	ld	b,a
	ld	c,95		; paletta-regiszterek I/O cme -1
	ld	hl,keppuff+4
pal:	inc	c		; paletta belltsa
	dec	de		; kirand hosszt is cskkenti
	outi			; regiszter lltsa, B=B-1
	jr	nz,pal
	ld	a,(keppuff+3)	; kp tpusa
	and	0FCh
	jr	z,kepre0	; mehet, ha csak sima formzatlan, tmrtetlen kp
	ld	hl,(fhossz)	; HL=fjlhossz
	ld	de,16
	or	a
	sbc	hl,de
	ex	de,hl		; DE=fjlhossz-16
	cp	8
	jr	z,kepre1	; formzott, tmrtetlen kp
	jp	kepre2		; formzott, tmrtett	kp
kepre0:	ld	b,d
	ld	c,e
	ld	de,32768
	di
	ld	a,80		; 50h = U0, U1, VID, SYS
	out	(2),a		; memrialapozs belltsa
	ldir			; teljes kppuffer tmsolsa a videomemriba
	ld	a,(3)		; eredeti lapozs vissza
	out	(2),a
	ei
	jp	kirveg
kepre1:	call	keppoz		; megjelentsi paramterek kiszmtsa
	di
	ld	a,80		; 50h = U0, U1, VID, SYS
	out	(2),a		; memrialapozs belltsa
kep1r:	push	bc
	push	de		; sor kezdetnek megjegyzse
	push	hl
	ld	a,(dspln)
	ld	c,a
	ld	b,0
	dec	bc		; utols bjtot mg nem
	ldir
	ld	a,(lbmask)
	and	(hl)
	ld	(de),a
	ld	hl,(scanln)	; forrs kvetkez sornak szmtsa
	pop	de
	add	hl,de
	ex	(sp),hl		; forrscm verembe, clcmet elveszi
	ld	de,64		; egy sor 64 bjt
	add	hl,de
	ex	de,hl		; DE=kvetkez sor eleje
	pop	hl		; HL=forrs kvetkez sora
	pop	bc		; B=sorszmll
	djnz	kep1r	
	ld	a,(3)		; eredeti lapozs vissza
	out	(2),a
	ei
	jp	kirveg
kepre2:	call	keppoz		; megjelentsi paramterek kiszmtsa
	di
	ld	a,80		; 50h = U0, U1, VID, SYS
	out	(2),a		; memrialapozs belltsa
	ld	hl,00
	ex	de,hl		; E=0 :egy sorba kirt bjtok szma
	push	hl		; HL=sor kezdete
	ld	a,(dspln)
	ld	c,a		; B=sorok szma  C=egy sor hossza bjtban
	exx
	ld	hl,keppuff+16
	ld	d,0		; count/data megklnbztet maszk
kep20:	ld	e,(hl)
	inc	hl
	ld	b,1		; count=1
	ld	a,0C0h
	and	e
	cp	d		; sszehasonlts a maszkkal
	jr	nz,kep22	; ugrs, ha a bjt adat
	ld	a,03Fh
	and	e
	ld	b,a		; count=als 6 bit
	dec	a		; count=1 ?
	jr	nz,kep21
	ld	a,64
	add	a,d
	ld	d,a		; maszk=maszk+64
kep21:	ld	e,(hl)		; adat=kvetkez bjt
	inc	hl
kep22:	ld	a,e		; A=adat	4
	exx			;		4
	ld	d,a		;		4
	inc	e		;		4
	ld	a,c		;		4
	cp	e		; E=dspln ?	4
	jr	z,kep23		;		7/12
	ld	(hl),d		;		7
	inc	hl		;		6
	exx			;		4
	djnz	kep22		;		13 : sum=61
	jp	kep20		; kvetkez RLE adat feldolgozsa
kep23:	ld	a,(lbmask)	; utols kpbjt maszkolsa
	and	d
	ld	(hl),a
	pop	hl		; HL=sor kezdete
	dec	b		; sorszmll cskkentse
	jr	z,kep24		; az sszes sor kirajzolva
	ld	de,64
	add	hl,de		; HL=kvetkez sor
	push	hl
	ld	e,0
	exx
	jp	kep20		; soronknt kell kdolni!!!
kep24:	ld	a,(3)		; eredeti lapozs vissza
	out	(2),a
	ei
kirveg: ret	
;
;
;
; A kp megjelentsi paramtereinek kiszmtsa a fejlcbjtok alapjn:
;
; return: B=sorok szma DE=kpernycm  HL=megjelentend adatok kezdete
;
keppoz:	ld	hl,(keppuff+8)	; X kiterjeds
	ld	a,(keppuff+3)	; kp tpusa
	and	03h		; sznek szma
	jr	nz,kep11
	ld	bc,0007		; 2-szn kp
	add	hl,bc		; felfel kerekts
	srl	h
	rr	l
	srl	h
	rr	l
	srl	h
	rr	l		; HL=HL/8
	ld	(scanln),hl	; sor hossza bjtokban, felfel kerektve
	ld	a,(keppuff+8)	; X kiterjeds als bjtja
	and	07h		; A=X mod 8
	ld	hl,gr2mask
	jp	kep13
kep11:	dec	a
	jr	nz,kep12
	ld	bc,0003		; 4-szn kp
	add	hl,bc		; felfel kerekts
	srl	h
	rr	l
	srl	h
	rr	l		; HL=HL/4
	ld	(scanln),hl	; sor hossza bjtokban, felfel kerektve
	ld	a,(keppuff+8)	; X kiterjeds als bjtja
	and	03h		; A=X mod 4
	ld	hl,gr4mask
	jp	kep13
kep12:	dec	a
	ret	nz		; hibs kp
	ld	bc,0001		; 16-szn kp
	add	hl,bc
	srl	h
	rr	l		; HL=HL/2
	ld	(scanln),hl	; sor hossza bjtokban, felfel kerektve
	ld	a,(keppuff+8)	; X kiterjeds als bjtja
	and	01h		; A=X mod 4
	ld	hl,gr16msk
kep13:	ld	c,a
	ld	b,0
	add	hl,bc
	ld	a,(hl)
	ld	(lbmask),a
	ld	hl,(scanln)	; megjelentend sorhossz ellenrzse
	ld	a,l
	ld	de,0064
	ex	de,hl
	or	a
	sbc	hl,de		; scanln>64 ?
	jr	nc,kep14
	ld	a,64
kep14:	ld	(dspln),a
	ld	hl,(keppuff+10)	; Y kiterjeds ellenrzse
	ld	de,240		; jelenleg max.240 lehet
	ex	de,hl
	or	a
	sbc	hl,de		; sszehasonlts, s HL-ben a klnbsg
	jr	nc,kep15	; ugrs, ha Y<=240
	ld	e,240
	ld	hl,00
kep15:	ld	b,e
	ld	a,0FEh		; 0.bit trlse
	and	l
	ld	l,a
	sla	l		; kp kzpre igaztsa
	rl	h
	sla	l
	rl	h
	sla	l
	rl	h
	sla	l
	rl	h
	sla	l
	rl	h		; HL=HL*32=HL/2*64, ennyi Y irnyban az eltols
	ld	a,(dspln)
	ld	e,a
	ld	a,64
	sub	e
	srl	a		; A=(64-dspln)/2, ennyi bjtot kell X irnyban eltolni
	ld	e,a
	ld	d,0
	add	hl,de
	ld	de,32768	; video memria kezdete
	add	hl,de
	ex	de,hl		; DE=kperny-cm
	ld	hl,keppuff+16	; HL=pixel adatok kezdete
	ret
;
hibair: ld	h,a		; kirja A reg.-ben adott hibt
	ld	bc,9
	ld	de,hszov
	rst	48
	.db	34		; ED_BKOUT blokk krsa kpernyre
	ld	a,h
	call	knv
	ld	c,72		; 'H' bet kirsa a szm utn
	rst	48
	.db	33
	rst	48		; vrakozs billenty lenyomsra
	.db	145		; KBD_CHIN
	ret
;
knv:	ld	l,2		; kirja A reg.-ben adott hexadecimlis szmot
	ld	h,a
	rrca
	rrca
	rrca
	rrca
p14:	and	15
	add	a,48
	cp	58
	jr	c,p15
	add	a,7
p15:	ld	c,a
	rst	48
	.db	33		; ED_CHOUT  karakterkirs
	ld	a,h
	dec	l
	jr	nz,p14
	ret
;
tip:	.db	0
kitolt:	.db	"   ."
hszov:	.db	"Hiba: A= "
minden:	.db	3,"*.*"
fhossz:	.db	0,0
atrb:	.db	0
;
scanln	.db	0,0					; egy kpsor bjtjainak szma
dspln	.db	0					; kpernyn egy sor bjtjainak szma
lbmask	.db	0					; az utols bjt maszkja
gr2mask	.db	0FFh,080h,0C0h,0E0h,0F0h,0F8h,0FCh,0FEh	; utols bjtok maszkja 2 sznnl
gr4mask	.db	0FFh,088h,0CCh,0EEh			; utols bjtok maszkja 4 sznnl
gr16msk	.db	0FFh,0AAh				; utols bjtok maszkja 16 sznnl
;
rdfnev	.db	0,0,0,0,0,0,0,0,0,0,0,0,0,0
utvonal	.db	0
	.db	0 ;92		; \
	.db	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
;
#include "lemezkez.asm"
fulpath	.equ	$		; teljes tvonalnv ellltshoz
				; (tfedsben van a lemezkezel halom-terletvel!!!)
;
keppuff	.equ	12000
;
.end

